#pragma once
#include <iostream>
#include <tuple>
#include <vector>
#include <unordered_map>
#include <string>
#include <set>
#include <unordered_set>
#include <array>
#include <ranges>
#include <algorithm>
#include <cmath>

struct Edge {
    std::pair<int, int> nodes;
    int middle_node;

    Edge() = default;
    Edge(int, int);

    Edge operator=(const Edge&);
    bool operator == (const Edge&) const;

    Edge create_edge(int, int);
    void update_mid(int);

    friend std::istream& operator >> (std::istream&, Edge&);
    friend std::ostream& operator << (std::ostream&, Edge&);

};



struct Node {
    int id;
    std::array<double, 3> ords;
    bool vertex=0;

    Node() = default;
    Node(int, const std::array<double, 3>&, bool);
    Node(const Node&);
   
    friend std::istream& operator>>(std::istream&,  Node&);
    friend std::ostream& operator<<(std::ostream&, const Node&);
};

struct Element {
    int element_id;
    int material_id;
    std::vector<int> node_id;

    Element() = default;
    Element(int, int, const std::vector<int>&);


    friend std::istream& operator>>(std::istream&, const Element&);
    friend std::ostream& operator<<(std::ostream&, const Element&);
};

struct ElemBoundary {
    int element_id;
    int surface_id;
    std::vector<int> node_id;

    ElemBoundary() = default;
    ElemBoundary(int, int, const std::vector<int>&);

    friend std::istream& operator >> (std::istream&, ElemBoundary&);
    friend std::ostream& operator << (std::ostream&, const ElemBoundary&);
};

